/*	Beispielprogramm, welches die Benutzung von EasyGEM
	in Verbindung mit Extended Objecttypen demonstriert.
	Autor: D. Rabich, Dlmen
	Datum: 3. Juli 1990
	Entwickelt mit Turbo C 2.0 von Borland.
*/

#include "easygem.h"	/* Headerdatei von EasyGEM */
#include "demo2.h"		/* Indizes der Resourcen */

BYTE rsrc_name[] = "DEMO2.RSC";	/* Name der Resourcedatei */
OBJECT *demodial;		/* Pointer auf Objectbaum */
14: BM rsric~_~] = TEN32.W1;

WORD apl_id;				/* Application-ID */
WORD v_handle;			/* Handle der VDI-Workstation */

/* Prototypen */

MLOCAL VOID tune_dial (OBJECT *dial, WORD obj);
WORD main (VOID);

/* Object verndern je nach Objecttyp */

MLOCAL VOID tune_dial (OBJECT *dial, WORD obj)
{
	WORD parent;
	
	switch ((dial[obj].ob_type & 0xFF00) >> 8)
	{
		/* Objekt innerhalb des Parents zentrieren */
		case 101:
			if((parent = GetParent(dial, obj)) != -1)
				dial[obj].ob_x=(dial[parent].ob_width - dial[obj].ob_width)/2;
		break;

		/* Objekt im Parent linksbndig */
		case 102:
			dial[obj].ob_x = 0;
		break;

		/* Objekt im Parent rechtsbndig */
		case 103:
			if((parent = GetParent (dial, obj)) != -1)
				dial[obj].ob_x = dial[parent].ob_width - dial[obj].ob_width;
			break;
	}
}

/* Hauptprogramm */
WORD main (VOID)
{
	/* anmelden, ID abspeichern */
	if ((apl_id = appl_init()) != -1)
	{
		/* Resourcedatei laden */
		if (rsrc_load (rsrc_name) != 0)
		{
			/* Adresse unserer Dialogbox ermitteln */
			rsrc_gaddr (R_TREE, DEMODIAL, &demodial);

			/* Extended Objects auswerten */
			TreeWalk (demodial, ROOT, tune_dial);

			/* virtuelle Workstation ffnen */
			v_handle = OpenWorkstation();

			/* Dialog durchfhren */
			DoDialog (demodial);

			/* virtuelle Workstation schlieen */
			CloseWorkstation (v_handle);

			/* Resourcedatei freigeben */
			rsrc_free();
		}

		/* abmelden */
		appl_exit();

		retum(0);
	}
	else
		return (1);
}
